
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>
#include <stdio.h>
#include "parser.h"

struct wch_struct {
	DWORD	adr;
	char	name[50];
	WORD	size;
};

WORD nbWatchers;

DWORD dwBytesToWrite, dwBytesWritten;

static void handleLine( char *line, HANDLE output)
{
	struct wch_struct newWatcher;
	BYTE	flag;
	DWORD fullsize = 4;
	int nbElem;

	ZeroMemory( newWatcher.name, 50);

	if (!line)	return;

	if ( Parser_Words_Count(line) == 3 )
	{
		nbElem = sscanf(line, "%x %1s %s", &(newWatcher.adr), &flag, newWatcher.name );
	}
	else
	{
		nbElem = sscanf(line, "%x %x %1s %s", &(newWatcher.adr), &fullsize, &flag, newWatcher.name );
	}

	if (!nbElem)	return;


	if ( newWatcher.adr < 0x00FF0000 )	return;
	if ( newWatcher.name[0] == '_')	return;
	if ( newWatcher.name[0] == '*')	return;
	if ( newWatcher.name[0] == 0)	return;

	newWatcher.size = (WORD) (fullsize & 0xFFFF);

	nbWatchers++;
	dwBytesToWrite = sizeof(newWatcher);
	WriteFile(output, &newWatcher, dwBytesToWrite, &dwBytesWritten, NULL) ;
}

int main(int argc, char* argv[])
{
	HANDLE hFr, hDest;
	DWORD i;


	if (argc != 3)
	{

		printf("nm2wch 0.1 - Kaneda 14 Dec 07\n");
		printf("Usage:\tnm2wch nm_output watcher.wch\n");
		return 0;
	}

	////// read source
	hFr = CreateFile(argv[1], GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFr == INVALID_HANDLE_VALUE)
	{
		printf("File not found");
		return -1;
	}

	if (!Parser_Load( hFr ))
	{
		CloseHandle(hFr);
		printf("%s",parser_error);
		return(-1);
	}

	CloseHandle(hFr);


	////// write output
	hDest = CreateFile(argv[2], GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
	if (hDest == INVALID_HANDLE_VALUE)
	{
		printf("Can't create output");
		return -1;
	}


	nbWatchers = 0;
	dwBytesToWrite = sizeof(nbWatchers);
	WriteFile(hDest, &nbWatchers, dwBytesToWrite, &dwBytesWritten, NULL) ;

	for(i=0; i< Parser_NumLine( ); i++)
	{
		handleLine( (char *) Parser_Line(i), hDest );
	}
	Parser_Unload( );


	SetFilePointer(hDest, 0, NULL, FILE_BEGIN);
	dwBytesToWrite = sizeof(nbWatchers);
	WriteFile(hDest, &nbWatchers, dwBytesToWrite, &dwBytesWritten, NULL) ;

	CloseHandle(hDest);


	return 0;
}